C To convert CD_data from ascii format  to SELCON3,CONTINLL,CDSSTR
c The CDPro programs
c Input INTERACTIVE -- File has wavelength, CDDATA   
c
	character*12 ifil
	character*4 name,ntitle(10)
	dimension cd(100),str(5)
c
	write(*,845)
845	format(75('_'))
	write(*,849)
849	format
     1 (/' This PROGRAM creates the INPUT file for CDPro Programs'//
     1   ' Some of the values are accepted interactively'/
     2   ' The CD data is read from a file with TWO VALUES per line'/
     3   ' First value is the WAVELENGTH, second CD DATA '/
     4 ' The wavelength is in the same order as range: say 260-180'/)

	write(*,845)
	write(*,851)
851     format(/'  Do you want to create a new INPUT file?',//
     1  '     If You Want to CREATE a NEW INPUT file, TYPE 0',/
     2  '     If you want to APPEND the existing INPUT file',
     3  '  TYPE 1'/)

	read(*,*)ifile
	OPEN (unit=7,file='INPUT')
c
	if (ifile.EQ.0) write(*,674)
	if (Ifile.NE.0) then
		write(*,673)           
89              read(7,100,end=90)
		goto 89
90              continue
		BACKSPACE (7)
	endif
673     FORMAT(/'  Data will be APPENDED to existing FILE: INPUT ')
674     FORMAT(/'  Any existing File: INPUT will be OVERWRITTEN ')
c
c  Initial Stuff: Title, Range, Skipping lines etc.
c
	write(*,845)
	write(*,91)
91      format(/'  Enter TITLE  for your data - 40 characters'/)
	read(*, 100) ntitle
	write(*,701) ntitle
701	format(/' TITLE:',2x,10a4)
	write(*,845)
c
	write(*,522)
522	format(/'  The number of lines to be skipped in CD file'/
     1  '  Enter the number of CD values per nm'/
     2	'  IF the DATA is .. 240nm, 241nm, 242nm etc. enter 1'/
     3	'  IF the DATA is .. 240nm, 240.5nm, 241nm etc. enter 2'/
     4	'  IF the DATA is .. 240nm, 240.2nm, 240.4nm etc. enter 5'/)

	read(*,*)resln
	iskip = int(resln)
	resln = 1/resln
	write(*,703)iskip,resln
703	format(/' Number of lines per nm in CD datafile',i4,
     1         /' Resolution of CD data:',f5.2,' nm')

	write(*,845)
	write(*,524)
524	format(/'  INPUT INITIAL wavelength: '/)
	read(*,*)wav1
	wavini = wav1
	write(*,845)
	write(*,526)
526	format(/'  INPUT FINAL wavelength: '/)
	read(*,*)wav2
	wavfin = wav2
	write(*,706)wav1,wav2
706	format(/' Wavelength Range: ',2f7.1,' nm')
	write(*,845)
c
	write(*,528)
528	format(/'  Is the CD data in Molar Ellipticity Units?'//
     1           '  IF IT IS TYPE 1; IF NOT TYPE 0'/
     2           '  If YOU TYPE 1 DATA WILL BE CONVERTED TO DELTA(e)'/)
	read(*,*)Delt
	write(*,845)
	if(Delt.EQ.0.0) write(*,622)
	if(Delt.NE.0.0) write(*,623)
622     format(/'  CD DATA IS ALREADY IN DELTA(e) UNITS.',
     1         ' NO CONVERSION DONE')
623     format(/'  CD DATA IS IN MOLAR ELLIPTICITY UNITS.'/,
     1         ' IT WILL BE CONVERTED TO DELTA(e) UNITS.'/)
        IF(Delt.EQ.0.0)Factor = 1.0
        IF(Delt.NE.0.0)Factor = 3300.0

c
c  INPUT FILE
c
	write(*,845)
	write(*, 116)
116     format(/' ASCII-file name (CD data)-MAX of 12 letters'/)
	read(*,109) ifil                
	write(*,708) ifil
708	format(/' CD data is contained in File:', a12)
	OPEN(unit=3,file=ifil)
	rewind(3)

	nsec = 6
c
c And, loop for successive sets of data written to INPUT
c

c	write(*,845)
        if(wav1.GT.wav2) ncd = int(wav1-wav2) + 1
        if(wav1.LT.wav2) ncd = int(wav2-wav1) + 1
        if(wav1.GT.wav2) WavLow = wav2 
        if(wav1.LT.wav2) WavLow = Wav1
103     format(3f12.4)
	

	write(*,845)
	write(*,142)resln,iskip-1,ifil
142     format(/'  Step Resolution in JASCO file was',f6.2,' nm',
     1  /'   If it is not betn .05 and 1.0, collect data in this range',
     2  /'  Every ',i3,' line(s) will be skipped in ',a12/)
	
	write(*,845)
	write(*,803)
803	format(/' Hit ENTER to CONTINUE'/'    Ctrl-C to ABORT')
	read(*,*)
       
109     format(a12)
	index=0
	do 10 j=1,ncd
		index=index+1
		read(3,*,end=202,err=203)wave,cd(index)
		write(*,*)index, j, wave, cd(index)
		cd(index)=(cd(index))/Factor
		  do 20 i=1,iskip-1
		     read(3,100,end=10)
20                continue
10             continue
c

	Iopt = 1
	If(WavLow.LT.190.0.AND.WavLow.GE.182) Iopt = 9 
	If(WavLow.GE.190.0) Iopt = 10 
c
c
        write(*,982)
        write(*,983)
982     format(//6x,' BASIS SET OPTIONS AVAILABLE',
     1  /6x,'_________________________________________________________'
     1  /6x,'|                                                       |'
     1  /6x,'| IBasis Ref.Set  Proteins   Secondary Structre WaveLen |'
     1  /6x,'|    1   SP29   29-SOLUBLE     H1,H2,S1,S2,T,U  178-260 |'
     2  /6x,'|    2   SP22X  22-SOLUBLE     H,3-10,S,T,P2,U  178-260 |'
     3  /6x,'|    3   SP37   37-SOLUBLE     H1,H2,S1,S2,T,U  185-240 |'
     4  /6x,'|    4   SP43   43-SOLUBLE     H1,H2,S1,S2,T,U  190-240 |'
     5  /6x,'|    5   SP37A  37-SOLUBLE       H,S,P2,T,U     185-240 |')
983      format
     1  (6x,'|    6   SDP42  SP37,5 Denatrd  H1,H2,S1,S2,T,U 185-240 |'
     7  /6x,'|    7   SDP48  SP43,5 Denatrd  H1,H2,S1,S2,T,U 190-240 |'
     8  /6x,'|    8   CLSTR  Soluble/Denatr. H1,H2,S1,S2,T,U 190-240 |'
     9  /6x,'|    9   SMP50  SP37,13 Membran H1,H2,S1,S2,T,U 185-240 |'
     1  /6x,'|   10   SMP56  SP43,13 Membran H1,H2,S1,S2,T,U 190-240 |'
     1  /6x,'|_______________________________________________________|')
c

	write(*,611)Iopt,WavLow
611	format(/' SELECT A IBasis VALUE: 1 to 10'/
     1    ' - Select a Ref.Set. with the max number of PROT possible -'
     1   /' - You can EDIT IBasis value in INPUT file & run CDPro -'
     9  //' Suggested Option:',i3,'  For CD data from:',f5.0/)
	read(*,*)IBasis
	If(IBasis.EQ.0) IBasis = Iopt
	Izero = 0
	Ione = 1
c
c write out to INPUT
c
	write(7,631)Izero,Ibasis
631	format('#                                                  '/
     #         '# PRINT    IBasis                                  '/
     1         ,3x,i4,6x,i4)
c
	write(7,6311)ntitle
6311    format('#                                                  '/
     #	       '#  ONE Title Line                                  '/
     1         ,10a4)
c
	write(7,632)
632	format('#                                                  '/
     #         '#     WL_Begin     WL_End       Factor             ')
	Fact = 1.0
	If(wav1.GT.wav2) write(7,103)wav1,wav2,Fact
	If(wav2.GT.wav1) write(7,103)wav2,wav1,Fact
c
	write(7,633)
633	format('#                                                  '/
     #         '# CDDATA (Long->Short Wavelength; 260 - 178 LIMITS ')
	If(wav1.GT.wav2) write(7,400)(cd(i),i=1,ncd)
	If(wav2.GT.wav1) write(7,400)(cd(i),i=ncd,1,-1)
c
	write(7,634)
634	format('#                                                  '/
     #         '#  IGuess  Str1   Str2   Str3   Str4   Str5    Str6'/
     1         '        0                                          ')
	write(*,845)
	write(*,709)
709	format(/'  The INPUT file for SELCON is')
	write(*,845)
	write(*,631)Izero,Ibasis
	write(*,6311)ntitle
	write(*,632)
	If(wav1.GT.wav2) write(*,103)wav1,wav2,Fact
	If(wav2.GT.wav1) write(*,103)wav2,wav1,Fact
	write(*,633)
	If(wav1.GT.wav2) write(*,400)(cd(i),i=1,ncd)
	If(wav2.GT.wav1) write(*,400)(cd(i),i=ncd,1,-1)
	write(*,634)
c
	go to 933
201     write(*,301)
301     format('  END OF FILE: ',a12,'  CHECK INPUT -JASCO- file')
	stop
202     write(*,302)ifil,wav1,wav2,resln
302     format(//'  END OF FILE: ',a12,' CHECK input parameters',/
     1  /'  Wavelength range AND Step resolution',
     2  /'  Current values are: Range -',2f6.1,' Step Rsln-',f4.1)
	stop
203     write(*,303)ifil
303     format('  Error in reading CD data from ',a12,' check input')
	stop

933     continue
100     format(10a4)
400     format(10f8.3)
	end
